﻿601,100
562,"NULL"
586,
585,
564,
565,"fJRhqma8xkfF^ga?g2LbSn4qwM7WGNHasoc8paL@59FW`cycyP3354Hvy<:FVd]\KM7]a2cgUk<e41tKqe2TYok=\d2B4PpuC6Hudd6ZT2@XiOywdYmqd7?ekiY[y9vtqp5b1jvu;w_pC=WPirgbiCbYX8CZTk`n^xBNg>Pab@K;>daHvKE8;55MBvGJJ>Yf7Q[MQ<_<"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,6
pExecutionId
pDimName
pDimDepth
pDimWidth
pTopNodeName
pControl
561,6
2
2
2
2
2
2
590,6
pExecutionId,"None"
pDimName,"MyBigH"
pDimDepth,"5"
pDimWidth,"8"
pTopNodeName,"B"
pControl,"Y"
637,6
pExecutionId,
pDimName,
pDimDepth,
pDimWidth,
pTopNodeName,
pControl,
577,0
578,0
579,0
580,0
581,0
582,0
572,96
#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################



cControlPrefix = '';
If (pControl @= 'Y');
cControlPrefix = '}';
EndIf;

# (Depth, Width) -> Size: 
# (5, 10) -> 10,000, 
# (6, 8) -> 25.000, 
# (8, 5) -> 40,000,
# (7, 7) -> 80,000,
# (6, 10) -> 100,000 
If (pDimName @= '' % pTopNodeName @= '');
ProcessError;
EndIf;

DimensionDestroy(pDimName);
DimensionCreate(pDimName);
AttrInsert(pDimName, '', 'Alias', 'A');

cDimWidth = NUMBR(pDimWidth);
cDimDepth = NUMBR(pDimDepth);
If (cDimWidth < 2 % cDimDepth < 2);
ProcessError;
EndIf; 

cOneDim = pDimName | '_one';
cAnotherDim = pDimName | '_another';
DimensionDestroy(cOneDim);
DimensionCreate(cOneDim);
DimensionDestroy(cAnotherDim);
DimensionCreate(cAnotherDim);

vParentDim = cOneDim;
vChildrenDim = cAnotherDim;

DimensionElementInsert(vParentDim, '', pTopNodeName, 'S');
vNodeType = 'c';
DimensionElementInsert(pDimName, '', pTopNodeName, vNodeType);
vLevel = 1;
While (vLevel < cDimDepth);

If (vLevel = cDimDepth - 1);
vNodeType = 'N';
EndIf;

vParentDimSize = DIMSIZ(vParentDim);
vIndexI = 1;
While (vIndexI <= vParentDimSize);

vElementI = DIMNM(vParentDim, vIndexI);
vIndexJ = 1;
While (vIndexJ < cDimWidth);

vElementJ = vElementI | '_' | TRIM(STR(vIndexJ, cDimWidth, 0));
DimensionElementInsert(vChildrenDim, '', vElementJ, 'S');
DimensionElementInsert(pDimName, '', vElementJ, vNodeType);
DimensionElementComponentAdd(pDimName, vElementI, vElementJ, 0);

vIndexJ = vIndexJ + 1;
End;

vElementJ = vElementI | '_' | TRIM(STR(cDimWidth, cDimWidth, 0));
DimensionElementInsert(pDimName, '', vElementJ, 'N');
DimensionElementComponentAdd(pDimName, vElementI, vElementJ, 0);

vIndexI = vIndexI + 1;
End;

DimensionDeleteAllElements(vParentDim);
vTempDim = vParentDim;
vParentDim = vChildrenDim;
vChildrenDim = vTempDim;

vLevel = vLevel + 1;
End;

DimensionDestroy(cOneDim);
DimensionDestroy(cAnotherDim);


573,1

574,1

575,90
#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################



# Create subset

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_test_CreateSubsetByDeletion', 
'pExecutionId', pExecutionId, 
'pDim', pDimName, 
'pSubset', pDimName, 
'pNode', '', 
'pDeleteOld', 'N',
'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

vMDX = 'HIERARCHIZE([' | pDimName | '].MEMBERS)';
SubsetCreateByMDX('Default', vMDX);

vMDX1 = 'DESCENDANTS([' | pDimName | '].[' | pTopNodeName | '_1' | '], 0, SELF_AND_AFTER)';
SubsetCreateByMDX('First_Branch', vMDX1);

If (cDimWidth > 2);

vMDX2 = 'DESCENDANTS([' | pDimName | '].[' | pTopNodeName | '_2' | '], 0, SELF_AND_AFTER)';
SubsetCreateByMDX('Second_Branch', vMDX2);
vMDX3 = 'INTERSECT(' | vMDX1 | ', ' | vMDX2 | ')';
vMDX4 = '{' | vMDX3 | ',' |  pTopNodeName | '}';
SubsetCreateByMDX('intersection_2', vMDX4);

EndIf;

StringGlobalVariable('gMdxFindDescendants');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_mdx_find_descendants', 
'pExecutionId', pExecutionId, 
'pDim', pDimName, 'pSubset', pDimName, 'pNode', pTopNodeName, 'pDepth', '1');
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
SubsetCreateByMDX('Shallow_Tree_1', gMdxFindDescendants);

If (cDimDepth > 2);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_mdx_find_descendants', 
'pExecutionId', pExecutionId, 
'pDim', pDimName, 'pSubset', pDimName, 'pNode', pTopNodeName, 'pDepth', '2');
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
SubsetCreateByMDX('Shallow_Tree_2', gMdxFindDescendants);
EndIf;

If (cDimDepth > 3);

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_mdx_find_descendants', 
'pExecutionId', pExecutionId, 
'pDim', pDimName, 'pSubset', pDimName, 'pNode', pTopNodeName, 'pDepth', '3');
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
SubsetCreateByMDX('Shallow_Tree_3', gMdxFindDescendants);

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_mdx_find_descendants', 
'pExecutionId', pExecutionId, 
'pDim', pDimName, 'pSubset', pDimName, 'pNode', pTopNodeName, 'pDepth', '3', 'pSelf', 'N');
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
SubsetCreateByMDX('Mult_branches_3', gMdxFindDescendants);

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_mdx_find_descendants', 
'pExecutionId', pExecutionId, 
'pDim', pDimName, 'pSubset', 'First_Branch', 'pNode', pTopNodeName, 'pDepth', '3', 'pSelf', 'N');
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
SubsetCreateByMDX('intersection_3', gMdxFindDescendants);
EndIf;
576,
638,1
804,0
1217,0
900,
901,
902,
903,
906,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,1
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
